//+------------------------------------------------------------------+
//|                                             Weighed WPRmulty.mq4 |
//|                                    Copyleft  2010 Zakharov Vdim |
//|                                                   aka Yuritch    |
//+------------------------------------------------------------------+

#property  indicator_separate_window
#property indicator_buffers     2
#property indicator_color1      Red
#property indicator_color2      Red
#property indicator_width1      1
#property indicator_width2      1
#property indicator_level1      -20
#property indicator_level2      -50
#property indicator_level3      -80
#property indicator_levelcolor  Gray
//---- input parameters

extern int    NumPairs = 8;
extern int    TF       = 0;
extern int    wpr_per  = 14;
extern string Pairs1   = "GBPUSD";
extern string Pairs2   = "EURJPY";
extern string Pairs3   = "AUDUSD";
extern string Pairs4   = "NZDJPY";
extern string Pairs5   = "EURUSD";
extern string Pairs6   = "GBPJPY";
extern string Pairs7   = "NZDUSD";
extern string Pairs8   = "AUDJPY";
extern string Pairs9   = "CHFJPY";
extern string Pairs10  = "EURCHF";
extern string Pairs11  = "GBPCHF";
extern string Pairs12  = "USDJPY";
extern string Pairs13  = "CADJPY";
extern string Pairs14  = "EURGBP";
extern int    Mode     = 0;
extern int    Limit    = 1;


double buf0[];
string Pairs[];
bool Recalculate=true;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorShortName("WPRM("+NumPairs+")("+TF+")");
   IndicatorBuffers(1);
   SetIndexStyle(1,DRAW_LINE,0,1);
   SetIndexBuffer(0,buf0);
   ArrayResize(Pairs,NumPairs);

   if (NumPairs > 0) Pairs[0] = Pairs1;
   if (NumPairs > 1) Pairs[1] = Pairs2;
   if (NumPairs > 2) Pairs[2] = Pairs3;
   if (NumPairs > 3) Pairs[3] = Pairs4;
   if (NumPairs > 4) Pairs[4] = Pairs5;
   if (NumPairs > 5) Pairs[5] = Pairs6;
   if (NumPairs > 6) Pairs[6] = Pairs7;
   if (NumPairs > 7) Pairs[7] = Pairs8;
   if (NumPairs > 8) Pairs[8] = Pairs9;
   if (NumPairs > 9) Pairs[9] = Pairs10;
   if (NumPairs > 10) Pairs[10] = Pairs11;
   if (NumPairs > 11) Pairs[11] = Pairs12;
   if (NumPairs > 12) Pairs[12] = Pairs13;
   if (NumPairs > 13) Pairs[13] = Pairs14;
   GetLastError();
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   if (Recalculate) 
      {
         ObjectCreate("wprm",OBJ_LABEL,WindowFind("WPRM("+NumPairs+")("+TF+")"),0,0);
         ObjectSet("wprm", OBJPROP_XDISTANCE, 5);
         ObjectSet("wprm", OBJPROP_YDISTANCE, 5);          
         ObjectSetText("wprm"," ",12,"Calibri Bols",Yellow);
      }
    else ObjectDelete("wprm");      
   int limit,err;
   double weight_sum=0,weight;

   limit = Bars;
   int i, j;
   for(j = 0; j < NumPairs; j++) {
   weight_sum = weight_sum + MarketInfo(Pairs[j],MODE_TICKVALUE);
   }
   double tmp0;
   if (limit>Limit && Limit>0 && !Recalculate) limit=Limit;
   for(i = limit; i > -1; i--) {
      tmp0 = 0.0;
      int timebar=iTime(NULL,TF,i);
     
      for(j = 0; j < NumPairs; j++) {
         weight=MarketInfo(Pairs[j],MODE_TICKVALUE)/weight_sum;
         int shift=iBarShift(Pairs[j],TF,timebar);
         if (iTime(NULL,TF,i)<iTime(Pairs[j],TF,shift)) shift++;
         tmp0 = tmp0 + iWPR(Pairs[j], TF, wpr_per, shift)*weight;
      }
      buf0[i] = tmp0;
   }
   Recalculate=false;
   return(0);
}

